> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Update Runner Policy

> Updates an existing runner policy.

`Unary` · [`Runners`](https://ona.com/docs/api-reference/generated/runner/overview)

Updates an existing runner policy.

Use this method to:

* Modify access levels
* Change group roles
* Update permissions

### Examples

* Update policy role:

  Changes a group's access level.

  ```yaml theme={null}
  runnerId: "d2c94c27-3b76-4a42-b88c-95a85e392c68"
  groupId: "f53d2330-3795-4c5d-a1f3-453121af9c60"
  role: RUNNER_ROLE_USER
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.RunnerService/UpdateRunnerPolicy
```

Send a Bearer token as described in [Authentication](https://ona.com/docs/api-reference.md#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

```bash cURL theme={null}
export ONA_HOST=https://app.ona.com
export ONA_API_KEY=<your-token>

curl --request POST \
  --url "$ONA_HOST/api/gitpod.v1.RunnerService/UpdateRunnerPolicy" \
  --header "Authorization: Bearer $ONA_API_KEY" \
  --header "Content-Type: application/json" \
  --data '{
  "runnerId": "<runner-id>"
}'
```

```python Python theme={null}
import gitpod.v1.runner_pb2 as runner_pb2
from ona_sdk import create_client_from_env

ona = create_client_from_env()
request = runner_pb2.UpdateRunnerPolicyRequest(
    runner_id="<runner-id>",
)
response = ona.services.runner.update_runner_policy(request)
print(response)
```

```typescript TypeScript theme={null}
import { create } from "@bufbuild/protobuf";
import { createClientFromEnv } from "@gitpod/sdk";
import { UpdateRunnerPolicyRequestSchema } from "@gitpod/sdk/gitpod/v1/runner_pb";

async function main() {
  const ona = createClientFromEnv();
  const request = create(UpdateRunnerPolicyRequestSchema, {
    runnerId: "<runner-id>",
  });
  const response = await ona.services.runner.updateRunnerPolicy(request);
  console.log(response);
}

main().catch(console.error);
```

```go Go theme={null}
package main

import (
	"context"
	"fmt"
	"log"

	"connectrpc.com/connect"
	"github.com/gitpod-io/gitpod-sdk-go/sdk"
	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
)

func main() {
	ona, err := sdk.NewFromEnv()
	if err != nil {
		log.Fatal(err)
	}

	request := connect.NewRequest(&gitpodpb.UpdateRunnerPolicyRequest{
		RunnerId: "<runner-id>",
	})
	response, err := ona.Services.Runner.UpdateRunnerPolicy(context.Background(), request)
	if err != nil {
		log.Fatal(err)
	}
	fmt.Println(response.Msg)
}
```

```json Request body theme={null}
{
  "runnerId": "<runner-id>"
}
```

## Request

`gitpod.v1.UpdateRunnerPolicyRequest`

UpdateRunnerPolicyRequest updates a Project Policy.

| Field | Type | Required | Description |
| - | - | - | - |
| `runnerId` | string | No | runner\_id specifies the project identifier Constraints: `string.uuid=true`. |
| `groupId` | string | No | group\_id specifies the group\_id identifier Constraints: `string.uuid=true`. |
| `role` | [RunnerRole](#enum-gitpod-v1-runner-role) | No | |

## Response

`gitpod.v1.UpdateRunnerPolicyResponse`

| Field | Type | Required | Description |
| - | - | - | - |
| `policy` | [RunnerPolicy](#type-gitpod-v1-runner-policy) | Yes | Constraints: `required=true`. |

## Related types

> [accordion] RunnerPolicy
>
> `gitpod.v1.RunnerPolicy`
>
> | Field | Type | Required | Description |
> | - | - | - | - |
> | `groupId` | string | No | Constraints: `string.uuid=true`. |
> | `role` | [RunnerRole](#enum-gitpod-v1-runner-role) | No | role is the role assigned to the group |

> [accordion] RunnerRole
>
> | Value | Number | Description |
> | - | -: | - |
> | `RUNNER_ROLE_UNSPECIFIED` | 0 | |
> | `RUNNER_ROLE_ADMIN` | 1 | |
> | `RUNNER_ROLE_USER` | 2 | |


This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.